%global dlrn 1
%define upstream_version 10.0.0
%{!?upstream_version: %global upstream_version %{version}%{?milestone}}
%global drv_vendor VMware
%global srcname vmware-nsx
%global docpath doc/build/html
%global service neutron

Name:           python-networking-%{srcname}
Version: 	10.0.0
Release: 	6%{?dist}
Provides: 	python2-networking-vmware-nsx = %{version}-%{release}
Summary:        %{drv_vendor} OpenStack Neutron driver

License:        ASL 2.0
# TODO: really, there are no packages on PyPI or anywhere else
URL:            https://pypi.python.org/pypi/%{srcname}
Source0: 	http://tarballs.openstack.org/%{srcname}/%{srcname}-%{version}.tar.gz

# patches_ignore=DROP-IN-RPM
# patches_base=10.0.0
Patch0001: 0001-NSX-V-Support-changing-the-position-of-LBAAS-L7-poli.patch
Patch0002: 0002-AdminUtils-NSXv3-Fix-SG-admin-utils-and-their-documa.patch
Patch0003: 0003-Update-tox_install-for-stable-ocata.patch
Patch0004: 0004-NSX-V-Fix-lbaas-l7-reject-action.patch
Patch0005: 0005-NSX-V-delete-old-pending-create-edges.patch
Patch0006: 0006-NSX-V-Improve-DHCP-edge-firewall-rules.patch
Patch0007: 0007-Use-vmware-nsxlib-stable-ocata.patch
Patch0008: 0008-NSX-T-Rewrite-client-certificate-unit-tests.patch
Patch0009: 0009-NSX-V-ensure-that-DVS-name-is-unique.patch
Patch0010: 0010-Use-stable-ocata-version-from-networking-sfc.patch
Patch0011: 0011-NSX-V3-Qos-without-RPC-notifications.patch
Patch0012: 0012-Updated-from-global-requirements.patch
Patch0013: 0013-NSXv3-Add-certificate-expiration-alert.patch
Patch0014: 0014-NSXv-Subnet-create-and-attachment-concurrency.patch
Patch0015: 0015-NSX-V-ensure-correct-parameter-is-passed.patch
Patch0016: 0016-Skip-configuring-integration-bride-on-ESXi-compute.patch
Patch0017: 0017-NSX-V3-Fix-QoS-delete.patch
Patch0018: 0018-NSXv3-Admin-Multiple-client-certificate-support.patch
Patch0019: 0019-Fix-to-use-correct-config-options-for-image_ssh_user.patch
Patch0020: 0020-NSX-V3-fix-devstack-cleanup.patch
Patch0021: 0021-NSXv3-Always-clean-client-certificate-in-devstack.patch
Patch0022: 0022-AdminUtils-NSX-V-fix-sections-reorder.patch
Patch0023: 0023-NSXv3-Hide-client-auth-password.patch
Patch0024: 0024-Prevent-non-admin-user-specifying-port-s-provider-se.patch
Patch0025: 0025-NSXv-NSXv3-Enable-address-scope-extension.patch
Patch0026: 0026-Fix-unit-tests.patch
Patch0027: 0027-NSX-V-Fix-exclusive-router-deletion.patch

# TODO: some of those dependencies are not available in repos, so left them version-less
BuildArch:      noarch
BuildRequires:  python2-devel
#BuildRequires:  python-mock >= 1.1
BuildRequires:  python-mock
BuildRequires:  python-oslo-sphinx
BuildRequires:  python-pbr
BuildRequires:  python-setuptools
BuildRequires:  python-sphinx
BuildRequires:  python-tenacity
BuildRequires:  python-vmware-nsxlib
# Required for config file generation
BuildRequires:  python-debtcollector
BuildRequires:  python-oslo-config >= 2:1.11.0
BuildRequires:  python-oslo-i18n >= 1.5.0
BuildRequires:  python-oslo-vmware >= 0.13.1
BuildRequires:  python-neutron

#Requires:      python-eventlet >= 0.17.4
Requires:       python-decorator
Requires:       python-enum34
Requires:       python-eventlet
Requires:       python-httplib2 >= 0.7.5
Requires:       python-netaddr >= 0.7.12
Requires:       python-neutron
Requires:       python-neutron-lib >= 1.1.0
Requires:       python-openstackclient >= 3.3.0
Requires:       python-osc-lib >= 1.2.0
Requires:       python-oslo-concurrency >= 3.8.0
Requires:       python-oslo-config >= 2:3.14.0
Requires:       python-oslo-db >= 4.15.0
Requires:       python-oslo-i18n >= 2.1.0
Requires:       python-oslo-log >= 3.11.0
Requires:       python-oslo-serialization >= 1.10.0
Requires:       python-oslo-service >= 1.10.0
Requires:       python-oslo-utils >= 3.18.0
Requires:       python-oslo-vmware >= 2.17.0
Requires:       python-pbr >= 1.8
Requires:       python-prettytable
Requires:       python-six >= 1.9.0
Requires:       python-sqlalchemy >= 1.0.10
Requires:       python-stevedore >= 1.17.1
#Requires:       python-tenacity >= 3.1.1
Requires:       python-tenacity
#Requires:      python-tooz >= 1.28.0
Requires:       python-tooz
Requires:       python-vmware-nsxlib

%description
This package contains %{drv_vendor} networking driver for OpenStack Neutron.


%package doc
Summary:        %{summary} documentation
Requires:       %{name} = %{version}-%{release}


%description doc
This package contains documentation for %{drv_vendor} networking driver for
OpenStack Neutron.


%prep
%setup -q -n %{srcname}-%{upstream_version}

%patch0001 -p1
%patch0002 -p1
%patch0003 -p1
%patch0004 -p1
%patch0005 -p1
%patch0006 -p1
%patch0007 -p1
%patch0008 -p1
%patch0009 -p1
%patch0010 -p1
%patch0011 -p1
%patch0012 -p1
%patch0013 -p1
%patch0014 -p1
%patch0015 -p1
%patch0016 -p1
%patch0017 -p1
%patch0018 -p1
%patch0019 -p1
%patch0020 -p1
%patch0021 -p1
%patch0022 -p1
%patch0023 -p1
%patch0024 -p1
%patch0025 -p1
%patch0026 -p1
%patch0027 -p1

rm requirements.txt test-requirements.txt


%build
%{__python2} setup.py build
%{__python2} setup.py build_sphinx
rm %{docpath}/.buildinfo


%install
export PBR_VERSION=%{version}
export SKIP_PIP_INSTALL=1
%{__python2} setup.py install --skip-build --root %{buildroot}

# Build config file
PYTHONPATH=. tools/generate_config_file_samples.sh

# Move config files to proper location
install -d -m 755 %{buildroot}%{_sysconfdir}/%{service}/plugins/vmware
mv etc/nsx.ini.sample %{buildroot}%{_sysconfdir}/%{service}/plugins/vmware/nsx.ini

%files
%license LICENSE
%{_bindir}/neutron-api-replay
%{_bindir}/neutron-check-nsx-config
%{_bindir}/nsxadmin
%{python2_sitelib}/vmware_nsx
%{python2_sitelib}/vmware_nsx-%{version}-py%{python2_version}.egg-info
%dir %{_sysconfdir}/%{service}/plugins/vmware
%config(noreplace) %attr(0640, root, %{service}) %{_sysconfdir}/%{service}/plugins/vmware/*.ini


%files doc
%license LICENSE
%doc %{docpath}


%changelog
* Wed Apr 19 2017 Steve Linabery <slinaber@redhat.com> 10.0.0-6
- NSX-V| Fix exclusive router deletion

* Mon Apr 17 2017 Steve Linabery <slinaber@redhat.com> 10.0.0-5
- Fix unit tests
- NSXv, NSXv3: Enable address-scope extension
- Merge "NSXv3: Add certificate expiration alert" into stable/ocata
- Merge "NSX-T: Rewrite client certificate unit tests" into stable/ocata
- Merge "Use vmware-nsxlib (stable/ocata)" into stable/ocata
- Merge "NSX|V Fix lbaas l7 reject action" into stable/ocata
- Merge "NSX|V: delete old pending-create edges" into stable/ocata
- Merge "AdminUtils NSXv3: Fix SG admin utils and their documantation" into stable/ocata

* Tue Apr 11 2017 Steve Linabery <slinaber@redhat.com> 10.0.0-4
- Prevent non-admin user specifying port's provider-security-groups
- NSXv3: Hide client auth password
- Merge "NSXv3: Add certificate expiration alert" into stable/ocata
- Merge "NSX-T: Rewrite client certificate unit tests" into stable/ocata
- Merge "Use vmware-nsxlib (stable/ocata)" into stable/ocata
- Merge "NSX|V Fix lbaas l7 reject action" into stable/ocata
- Merge "NSX|V: delete old pending-create edges" into stable/ocata
- Merge "AdminUtils NSXv3: Fix SG admin utils and their documantation" into stable/ocata

* Mon Apr 03 2017 Jon Schlueter <jschluet@redhat.com> 10.0.0-3
- AdminUtils NSX-V| fix sections reorder
- NSXv3: Always clean client certificate in devstack
- NSX-V3| fix devstack cleanup
- Fix to use correct config options for image_ssh_user
- NSXv3 Admin: Multiple client certificate support
- NSX-V3: Fix QoS delete
- Skip configuring integration bride on ESXi compute
- NSX|V: ensure correct parameter is passed
- NSXv: Subnet create and attachment concurrency
- Merge "NSXv3: Add certificate expiration alert" into stable/ocata

* Wed Mar 29 2017 Jon Schlueter <jschluet@redhat.com> 10.0.0-2
- NSXv3 Admin: Multiple client certificate support
- NSX-V3: Fix QoS delete
- Skip configuring integration bride on ESXi compute
- NSX|V: ensure correct parameter is passed
- NSXv: Subnet create and attachment concurrency
- Merge "NSXv3: Add certificate expiration alert" into stable/ocata
- NSXv3: Add certificate expiration alert
- Updated from global requirements
- NSX-V3| Qos without RPC notifications

* Wed Mar 29 2017 Jason Joyce <jjoyce@redhat.com> 10.0.0-1
- Update to 10.0.0

